import 'dart:async';

import 'package:connectivity/connectivity.dart';

enum CBConnectivityStatus { WiFi, Cellular, Offline }

class CBConnectivityService {
  static StreamController<CBConnectivityStatus> connectionStatus =
      StreamController<CBConnectivityStatus>();

  static init() {
    Connectivity().onConnectivityChanged.listen((ConnectivityResult result) {
      connectionStatus.add(_getStatusFromResult(result));
    });
  }

  /// Convert from the third part enum to our own enum
  static CBConnectivityStatus _getStatusFromResult(ConnectivityResult result) {
    switch (result) {
      case ConnectivityResult.mobile:
        return CBConnectivityStatus.Cellular;
      case ConnectivityResult.wifi:
        return CBConnectivityStatus.WiFi;
      case ConnectivityResult.none:
        return CBConnectivityStatus.Offline;
      default:
        return CBConnectivityStatus.Offline;
    }
  }
}
